\chapter{Number Theory or The Great Beloved}
\label{ch:Number Theory}
Despite being easy and fast to read \href{https://en.wikipedia.org/wiki/Number_theory}{number theory} problems are such hard to solve that many of the yet unsolved problems are related to this mathematical area. They are about integers and basic relationship between numbers, such as congruences, divisors, prime numbers $\ldots$ with which the curious reader will have fun.

\section{Cakes}
\label{sec:Cakes}
How about starting the first chapter of a mathematical-boring-useless kind of book with a subject that will gain everyone respect and attention? Let's talk about CAKES!
Imagine you have placed $n$ candles on the edge of your $n$-th birthday cake and you cut the cake along all segments between any two candles. How many friends can you feed at your $n$-th birthday?\\
Well, it looks like there is a simple formula to calculate the number of all possible slices given $n$ candles: $2^{n-1}$. Yet when $n=6$ things get bad \ldots how is that possible? And besides, what is the correct formula? The reader may be surprised to know that the possible slices with $n$ candles are
$$
\begin{aligned}
s_n &= \sum \limits_{k=0} ^4 \binom{n-1}{k}\\
&= \binom{n-1}{0} + \binom{n-1}{1} + \binom{n-1}{2} + \binom{n-1}{3} + \binom{n-1}{4}\\
&= + (n-1) + \frac{(n-1)\cdot (n-2)}{2} + \frac{(n-1)\cdot (n-2)\cdot (n-3)}{3!}\\
&+ \frac{(n-1)\cdot (n-2)\cdot (n-3)\cdot (n-4)}{4!}\\
&=\boxed{\frac{n^4 - 6n^3 +23n^2 - 18n + 24}{24}}
\end{aligned}
$$

\section{Perfect numbers}
\label{sec:Perfect numbers}
\textit{Perfect} might sound too pretentious for \cite{Natural_Number_Wikipedia}, but how would you call a number that equals the sum of its divisors? That is the definition of \textit{perfect number}, that was given by \cite{Euclid_Wikipedia} in \cite{Euclid_Elements_Wikipedia}.\\
Such numbers are so rare that by \cite{Euclid_Euler_Theorem_Wikipedia} a perfect number is such if and only if it is of the form $\frac{M(M+1)}{2}$, where $M$ is \cite{Mersenne_Prime_Wikipedia}: this means that the $M$-\hyperref[sec:N-agonal numbers]{triangular number} is a perfect number! These kind of numbers are as important as elusive: in fact there is a list of unsolved questions about them, like \textit{Are there any odd perfect numbers?} or \textit{Are there infinitely many perfect numbers?}

\section{Lucas' numbers}
\label{sec:Lucas numbers}
Every one has heard at least once in their lifetime about Fibonacci numbers. Even sunflowers and snails know about the famous sequence! But how about Lucas' numbers?\\
In mathematics Lucas' numbers, named after \cite{Edouard_Lucas_Wikipedia}, are similar to Fibonacci ones as for the basic structure but the Lucas' sequence starts slightly different:
$$\begin{cases}
L_1 = 2, L_2 = 1\\
L_n = L_{n-1} + L_{n-2}, \forall n \in \mathbb{N}\\
\end{cases}$$
We can build up a table with small values of Lucas' numbers:
$$\begin{array}{c|lcr}
n & L_n \\
\hline
1 & 2 \\
2 & 1 \\
3 & 3 \\
4 & 4 \\
5 & 7 \\
6 & 11 \\
\ldots & \ldots
\end{array}$$
What is interesting is that calculating Lucas' numbers is extremely easier than calculating Fibonacci ones. Given that Golden ratio $\phi \approx 1.618\ldots$
$$[\phi ^ n] = L_{n+1}$$
$$\forall n \in \mathbb{N} | n \ge 2$$

\section{Liouville number}
\label{sec:Liouville number}
Liouville number has been \textit{found} by, guess who?, \cite{Joseph_Liouville_Wikipedia} in 1844. No explanations, may the force be with the reader and help him/her find a pattern:
$$L = 0.110001000000000000000001\ldots$$
Don't you see it? It's rather simple!
\begin{enumerate}
\item Start with an infinite string of $0s$
\item Turn a $0$ into a $1$ every time you run into a $n!$-th digit $\forall n \in \mathbb{N}$, after the leading $0$.
\end{enumerate}

\section{Lychrel numbers}
\label{sec:Lychrel numbers}
How much maths-addicted you should be to name some integers with special properties like your girlfriend? This is what happened when Wade VanLandingham called a kind of integers with an anagram of his girlfriend name, Cheryl. Let's discover what's particular of these integers.\\
Write down a positive intege, then add the number obtained by reversing its digits, and stop when you get \cite{Palindromic_Number_Wikipedia} \ie{}
\begin{itemize}
\item 23: $23 + 32 = 55$
\item 125: $199 + 991 = 1190 \to 1190 + 0911 = 2101 \to 2101 + 1012 = 3113$
\end{itemize}
The numbers who don't actually reach any palindrome are called Lychrel numbers. The question is: what are these numbers? By mean of computer programming mathematicians found that 196, 295, 394, 493, 592, 689, 691, 788, 790, 879 $\ldots$ don't reach any palindrome even after about \textit{million} of iterations. There is even \cite{Lychrel_seeds} which contains a list of all the \textit{possible} Lychrel numbers as well as some datasets with relevant information.

\section{Gauss' circle problem}
\label{sec:Gauss circle problem}
Suppose a friend of yours is a gold-finder who looks for gold along the Missouri river with a circular sieve. Maybe this is not much frequent nowadays, so let's time-travel to 1777, exactly the year when \cite{Carl_Friedrich_Gauss_Wikipedia} was born.\\
Let's imagine that your friend's sieve consist of parallel and perpendicular lines which meet each other at some points inside the external circumference. The question is, how many intersections are there \textbf{inside} the circumference?\\
Luckily in those years a famous and very clever mathematician was born and started to wander in this world keeping asking himself for solution of problems like this one.\\
Formally in mathematics this problem is defined as follows:\\
$$\text{Given a circle with equation }x^2 + y^2 = r^2,$$
$$\text{ define } N(r) = ||(m,n)|| \text{ such that } m,n \in \mathbb{Z} \and m^2 + n^2 \le r^2.$$
$$\text{Find } N(r).$$
Gauss found an approximation of this number:
$$N(r) \approx [\pi r^2]$$
$$N(r) = [\pi r^2] + e(r), e(r) \le 2\sqrt{2}\pi r$$

As you can imagine $e(r)$ represents the "error" of the approximation in function of the radius $r$.\\
This problem is also known as \cite{Gauss_Circle_Problem_Wikipedia} and beside there is a solution, not only an approximation:
$$\boxed {N(r) = 1 + \sum\limits_{i=0} ^{+\infty} \Bigl\lfloor \frac{r^2}{4i + 1}\Bigr\rfloor  -\Bigl \lfloor\frac{r^2}{4i+3}\Bigr \rfloor}$$
\begin{figure}[ht!]
\centering
\includegraphics[width=70mm]{ch/number-theory/img/gauss_circle.png}
\caption{Lattice grid with circle}
\end{figure}

\section{Universal divisibility criteria}
\label{sec:Universal divisibility criteria}
This chapter can be a little tricky to the less-experienced reader, but the author is sure definitions and proofs are written in the most easy-to-read way, so that every kind of reader can appreciate the topic.\\
The aim of this chapter is to develop a universal \href{https://en.wikipedia.org/wiki/Divisibility_rule}{divisibility rule} for each number in \cite{Decimal_Wikipedia}.
So when we write $a \in \mathbb{N}$ we are usually meaning $a = 10 ^n \cdot a_n + 10^{n-1} \cdot a_{n-1} + \ldots + 10^2 \cdot a_2 + 10^1 \cdot a_1 + 10^0 \cdot a_0$.
Preliminaries done, now the statement. Let $p$ be a prime number $\neq 2,5$, then
$$a \equiv 0 \mod p \iff \left( \Bigl\lfloor \frac{a}{10} \Bigr \rfloor - k \cdot a_0 \right) \equiv 0 \mod p$$
Note: that part of sentence $\left( \Bigl\lfloor \frac{a}{10} \Bigr \rfloor - k \cdot a_0 \right)$ means \textit{a without last digit and subtracted } $a_0$ $k$ \textit{times}.
The proof is very easy and involves basic \hyperref[ch:Number Theory]{Number Theory} elements and operations, so now let's see some practical examples.\\
If the readers work out some calculations they will find a similar table
$$k =
\begin{cases}
\frac{p-1}{10} \iff p \mod 10 \equiv 1\\
\frac{7p-1}{10} \iff p \mod 10 \equiv 3\\
\frac{3p-1}{10} \iff p \mod 10 \equiv 7\\
\frac{9p-1}{10} \iff p \mod 10 \equiv 9
\end{cases}$$
and the following table comes out immediately
$$\begin{array}{c|c|c}
p & p \mod 10 & k_p \\
\hline
3 & 3 & 2\\
7 & -3 & 2\\
11 & 1 & 1\\
13 & 3 & 9\\
17 & -3 & 5\\
19 & -1 & 17\\
23 & 3 & 16\\
29 & -1 & 26\\
\ldots & \ldots & \ldots
\end{array}$$
e.g
$$29 | 1885 \iff 29 | 188 - 5 \cdot 26 = 58 = 29 \cdot 2 \implies$$
$$29 | 1885$$

\section{Is $12345678 \ldots $ prime?}
\label{sec:Is 12345678 prime?}
Let $f_n$ be the number obtained by concatenating the first $n$ numbers in \cite{Decimal_Wikipedia}. For example
$$f_1 = 1, f_2 = 12, f_3 = 123, f_13 = 12345678910111213$$
Is $f_n$ always composite? That's a hard question, unsolved yet. However we have some hints about the solution.\\
\cite{A007908_Oeis} represents the general term $f_n$, and the problem has already been asked in \cite{Unsolved_Problems_In_Number_Theory_Wikipedia} by \cite{Richard_K_Guy_Wikipedia}. There are no primes in the first $20000$ terms of the sequence, but heuristics suggest that there are infinitely many. In particular, there \text{should} be about
$$\frac{\log\log n-\log\log m}{2}$$
primes between $m$ and $n$. This suggests that there should be about one prime with index between $20000$ and $\exp(\exp(\log(\log 5000)+2))\approx6\cdot10^{31}$

\section{Diophantine equations}
\label{sec:Diophantine equations}
Let $a,b,c \in \mathbb{Z}$ and $d = \hyperref[sec:MCD magics]{MCD}(a,b)$, then solve the equation
$$ax + by = c\quad \quad(1)$$
Too brutal indeed \ldots poor reader. Luckily a man called Diophantus who lived in ancient Greece worked all solutions out in a simple and elegant way.
\begin{itemize}
\item $\exists x,y \in \mathbb{Z} | (1) \text{ is satisfied} \iff d | c$
\item $\textbf{all} \text{ such } x,y \text{ are of the form}$
$\begin{cases}
x = x_0 + \frac{b\cdot t}{d}\\
y = y_0 - \frac{a\cdot t}{d}\\
t \in \mathbb{Z}
(x_0, y_0) \text{ is a solution of } (1)
\end{cases}$
\item if $d = 1$ ($a,b$ are co-primes) and a solution $\in \mathbb{N}_0$ is desired, then the number of such solutions is $s$ such that $-\frac{x_0}{b} < s < \frac{y_0}{a}$. In particular there are at least $n$ solutions $\iff c > abn$. 
\end{itemize}
Moreover if we apply those statements in solving the congruence
$$ax \equiv b \mod m \iff ax = my + b \iff ax - my = b$$
we discover that
\begin{itemize}
\item $\exists x \iff d' = MCD(a,m) | b$
\item there are \hyperref[sec:A note on notations (cit.)]{exactly } $d$ solutions given by the general formula $x = x_0 + \frac{mt}{b}$ where $x_0$ is a solution and $t \in \mathbb{N} | 0 \le t \le d-1$
\end{itemize}
This kind of equation belongs to \cite{Linear_Diophantine} equations, while equations like $a\cdot x^2 + c \cdot y^2 = k$ belong to \cite{Diophantine_Equation_2Nd_Powers_From_Wolfram_Mathworld}. There are even \href{cubic Diophantine}{http://mathworld.wolfram.com/DiophantineEquation3rdPowers.html} equations, but they are so hard to solve that mathematicians preferred stop here and not explore hyper Diophantine equations.

\section{Leyland numbers}
\label{sec:Leyland numbers}
Although some readers may recall \cite{Leyland_Brothers}, almost none of them would think about Number Theory at the word Leyland. Yet Leyland numbers play a great role in this Mathematical field.\\Formally a Leyland number is any integer of the form
$$x^y + y^x$$
$$ \forall x,y, \in \mathbb{N} | x,y \ge 2$$
$$e.g. \text{ }8, 17, 32, 54, 57 \ldots$$
What may be surprising is that some Leyland number are also prime numbers, and the Leyland numbers (6753, 5122) and (8656, 2929) are among the biggest prime numbers ever found, with about $3\cdot 10^4$ digits.

\section{$n-$th power and a prime number}
\label{sec:n-th power and a prime number}
Show that for any positive integer $ l$, there exist positive integers $n$ such that
$$n^n+47\equiv 0\pmod{2^l}$$
\begin{proof}
For $l \le 4$ we have $n=1$, so suppose $l>4$. Now, if $n^n+47\equiv0\pmod{2^l}$ but $n^n+47\not\equiv0\pmod{2^{l+1}}$ we have
$$\begin{cases}
(n+2^l)^{n+2^l}\equiv(n+2^l)^n \mod 2^{l+1}\\
(n+2^l)^n =\sum_{j=0}^n\binom nj n^j2^{l(n-j)}= n^n+n\cdot n^{n-1}2^l+2^{2l}s= n^n(1+2^l)+2^{2l}s
\end{cases}$$
for some integer $s$.
Since $2^l |  n^n+47$ but $2l+1$ doesn't, $n^n+47 \equiv 2l \mod (2l+1)$. Taking modulus $2l+1$ in the former equation 
$$
\begin{aligned}
(n+2^l)^n &\equiv (2^l-47)(1+2^l)\\
&\equiv -46\cdot2^l-47\\
&\equiv -47\pmod{2^{l+1}}
\end{aligned}$$
\end{proof}

\section{MCD magics}
\label{sec:MCD magics}
Given that $GCD(a,b) = x = \text{ the greatest number such that } x|a \text{ } \& \text{ } x | b,$ what is $GCD(a+c, b+c), \forall a,b,c,x \in \mathbb{N}?$
It's rather simple, even if it may seem one of the toughest questions in Number Theory \ldots
$$GCD(a+c, b+c) = GCD(GCD(a,b), c) = GCD(x,c)$$

\section{Lucas-Lehmer primality}
\label{sec:Lucas-Lehmer test}
Testing whether a natural number is prime or not is such a tedious and heavy job that numerous \href{https://en.wikipedia.org/wiki/Primality_test}{tests} have been developed to speed things up. Here it is one of them.
\begin{thm}
Let $q$ be an odd prime number and define a sequence $L$ to be:
$$\begin{cases}
L_0 = 4\\ 
L_{n+1} = (L_n ^2 -2) \mod (2^q -1), \forall n \in \mathbb{N} \\ 
\end{cases}$$
Then $$2^q - 1 \text{ is prime } \iff L_{q-2} = 0$$
\end{thm}

\section{Antiprimes}
\label{sec:Antiprimes}
What do Plato and Ramanujan have in common? Antiprimes.\\
A highly composite number (or anti-prime) is a positive integer with more divisors than any smaller positive integer has. Plato, who set 5040 as the ideal number of citizens in a city as 5040 has more divisors than any numbers less than it, maybe the first to have noticed these kind of numbers, but Ramanujan coined the term in 1915. The first of these kind are $1, 2, 4, 6, 12, 24, 36, 48, 60, 120, 180, 240, 360, 720, 840, 1260, 1680, 2520, 5040,$\\
$7560, 10080, 15120, 20160, 25200, 27720, 45360, 50400, 55440, 83160, 110880,$\\
$166320, 221760, 277200, 332640, 498960, 554400, 665280, 720720, 1081080,$\\
$1441440, 2162160$ (see \cite{A002182_Oeis} \moreinfo).
What is more interesting is that, let $Q(x)$ be the number of such numbers $\le x$, then there exists 2 constant $a, b > 1$ such that
$$
\ln(x)^a \le Q(x) \le \ln(x)^b
$$
moreover we have been able to prove that
$$
1.13862 \le \lim \inf \frac{Q(x)}{\log \log x} \le 1.44
$$
and
$$
\lim \sup \frac{Q(x)}{\log \log x} \le 1.71
$$

\section{Derangements}
\label{sec:derangements}
A secretary is leaving the office on a Friday evening: she wants to rush home to party but she's handed a bag of letters and envelopes with the address to be sent to. She starts grabbing a letter and inserting it into a envelope and fills all the envelopes by such method. What is the probability that \textit{at least one} letter is in the right envelope?

One way to solve this problem is count how many \textbf{derangements} (\ie{} a permutation that has no fixed points) there are. Given the number of letters is $n$, such number is
$$!n \approx \frac{n!}{e}$$

\section{Every positive integer is a sum of three palindromes}
\label{sum-of-three-palindromes}
See \cite{Ams_Mathematics_Of_Computation} \moreinfo.

\section{Gauss’ golden theorem}
\label{gauss-golden-th}
Given that
\begin{itemize}
\item odd prime $p$
\item integer $a$, such that $a$ is not a multiple of $p$
\end{itemize}
$$\text{does }a \text{ have a square root mod } p \text{?}$$
\ie{}
$$\exists x \mid x^{2} = a \mod p?$$

Easy: square all the integers from 1 to p-1 and see whether one of them is congruent to a. Yet, for large integers it's not feasible. We thus introduce a little of mathematical notation:

\subsection{Legendre symbols}
$$\genfrac(){}{0}{a}{b} =
\begin{cases}
1 \iff a \text{has a square root mod } p\\
-1 \text{ otherwise}
\end{cases}$$
One key fact is that $\forall m,n$ such that $m,n$ are not multiples of $p$
$$\genfrac(){}{0}{m}{p} \cdot \genfrac(){}{0}{n}{p} = \genfrac(){}{0}{mn}{p}$$
thus we can factor $a$ and tell $\genfrac(){}{0}{a}{b}$ by looking at $a$'s factors Legendre symbols.
This leads to the aforementioned Gauss theorem:
$$\text{if } p, q \text{ are odd primes}$$
$$\genfrac(){}{0}{p}{q} \cdot \genfrac(){}{0}{q}{p} = (-1) ^ {\frac{p - 1}{2} \cdot \frac{q - 1}{2}}$$

\section{Brun's theorem}
\label{brun-th}
\begin{itemize}
	\item There are infinite primes, right?
	\item There are infinite twin-primes, right?
	\item The sum of the reciprocals of the primes is infinite.
	\item Well, the sum of the reciprocals of the twin primes is \textbf{not} infinite. It converges to Brun's constant, discovered in 1919 by the 34-year-old Norwegian Viggo Brun.
\end{itemize}

The convergence of the sum of reciprocals of twin primes follows from bounds on the density of the sequence of twin primes. Let $f(x)$ denote the number of primes p $\le$ x for which p + 2 is also prime (\ie{}. the number of twin primes with the smaller at most x). Then, for $x \ge 3$, we have
$$f(x) = \mathcal{O}(\frac{x(\log \log x)^2}{(\log x)^2})$$
this means that the twin primes are less frequent than prime numbers by nearly a logarithmic factor. Thus the sum of the reciprocals of the twin primes converges, or stated in other words, the twin primes form a small set. Such sum is $\approx 1.902160583104$.

\section{Reciprocals of primes}
\label{sec:reciprocals-of-primes}
$$\text{For any prime }p \text{ except 2 and 5, the decimal expansion of } \frac{1}{p} \text{repeats with a period that divides } p-1$$
e.g
$$\begin{array}{c|c|c|c|c}
p & p - 1 & \frac{1}{p} & \text{period length}\\
\hline
3 & 2 & 1/3 = 0.\overline{3} & 1 \\
7 & 6 & 1/7 = 0.\overline{142857} & 6 \\
11 & 10 & 1/11 = 0.\overline{09} & 2\\
13 & 12 & 1/13 = 0.\overline{076923} & 6\\
17 & 16 & 1/17 = 0.\overline{0588235294117647} & 16\\
19 & 18 & 1/19 = 0.\overline{052631578947368421} & 28\\
23 & 22 & 1/23 = 0.\overline{0434782608695652173913} & 22
\end{array}$$
